<template>
  <v-card>
    <v-toolbar flat>
      <v-toolbar-title>
        <v-icon color="info" class="mx-2">timeline</v-icon>
        รายได้
      </v-toolbar-title>
      <v-flex shrink>
        <v-select
          class="mx-5"
          style="background-color: ##c7c7c7"
          v-model="IncomeRangeSelected"
          :items="IncomeChoice"
          item-text="choiceName"
          item-value="choiceValue"
          prepend-icon="mdi-calendar"
          menu-props="auto"
          hide-details
          label="Select"
          single-line
        ></v-select>
      </v-flex>
    </v-toolbar>
    <v-card-text>
      <div class="my-4" v-if="loadingIncome">
        <CardLoading></CardLoading>
      </div>
      <div class="my-4" v-else>
        <v-row>
          <v-col cols="12">
            <graph-stackbar
              :paddingTop="50"
              :theme="'classic'"
              :height="400"
              :labels="stackChartDate"
              :full-mode="false"
              :show-text="true"
              :names="rateTypeName"
              :values="stackChartValue"
              :barMargin="20"
            >
              <legends :names="rateTypeName"></legends>
              <tooltip :names="rateTypeName" :position="'center'"></tooltip>
            </graph-stackbar>
          </v-col>
        </v-row>
      </div>
    </v-card-text>
  </v-card>
</template>

<script>
import CardLoading from "./CardLoading";
export default {
  components: {
    CardLoading,
  },
  data() {
    return {
      loadingIncome: true,
      IncomeRangeSelected: "W",
      stackChartDate: [],
      stackChartValue: [],
      rateTypeName: [],
      IncomeChoice: [
        {
          choiceName: "ต่อสัปดาห์",
          choiceValue: "W",
        },
        {
          choiceName: "ต่อเดือน",
          choiceValue: "M",
        },
        {
          choiceName: "ต่อปี",
          choiceValue: "Y",
        },
      ],
    };
  },
  watch: {
    async IncomeRangeSelected() {
      await this.fetchIncome();
      this.loadingIncome = false;
    },
  },
  async created() {
    await this.fetchIncome();
    this.loadingIncome = false;
  },
  methods: {
    async fetchIncome() {
      this.stackChartDate = [];
      this.stackChartValue = [];
      this.rateTypeName = [];
      await this.$store.dispatch(
        "dashboard/getIncome",
        this.IncomeRangeSelected
      );
      this.stackChartDate = this.$store.getters["dashboard/income"].label;
      this.rateTypeName = this.$store.getters["dashboard/income"].rateTypeName;
      this.stackChartValue = this.$store.getters["dashboard/income"].value;
    },
  },
};
</script>

<style>
</style>